#and their baseball team, the wankees.
import asyncio
from concurrent.futures import ProcessPoolExecutor
from io import BytesIO
from PIL import Image
import json
import httpx
import fp_globals


def initNetworkPool():
    global httpxClientCache
    httpxClientCache = {}


def networkPoolJob(func):
    def wrapper(httpxParams: tuple, *args, **kw):
        # Runs in the subprocess
        global httpxClientCache
        try:
            httpxClient = httpxClientCache[httpxParams]
        except KeyError:
            httpxClient = httpx.AsyncClient(httpxParams)
            httpxClientCache[httpxParams] = httpxClient
        kw["session"] = httpxClient
        func(*args, **kw)
    return wrapper


def initWorkers(app):
    app.networkPool = ProcessPoolExecutor(max_workers=2,
                                          initializer=initNetworkPool)
    app.mediaPool = ProcessPoolExecutor(max_workers=2)
    app.ioPool = ProcessPoolExecutor(max_workers=2) #inb4...
    return app.mediaPool


def thumbnailImage(imageData, imageFormat, size=150):
    imageObject = Image.open(BytesIO(imageData))
    imageObject.thumbnail((size, size))
    imageBlob = BytesIO()
    imageObject.save(imageBlob, format=imageFormat)
    return imageBlob