from PyQt5.QtWidgets import QAction, QLabel
from fe_gui import subwindows
from fe_core import fp_globals, fp_sqlite


def openDiscoverInstanceDialog():
    w = subwindows.discoverInstanceDialog(fp_globals.Application)


def addNewAccountWithDialog():
    w = subwindows.addAccountDialog(fp_globals.Application)


def openNewStatusDialog(self):
    w = subwindows.newStatusDialog(fp_globals.Application)


def initActions(app):
    app.exitAction = QAction('&Exit', app)
    app.exitAction.setShortcut('Ctrl+Q')
    app.exitAction.triggered.connect(app.close)
    app.openDiscoverInstanceDialog = QAction("Discover instance...", app)
    app.openDiscoverInstanceDialog.triggered.connect(openDiscoverInstanceDialog)
    app.openNewStatusDialogAction = QAction("New Status", app)
    app.openNewStatusDialogAction.setShortcut('Ctrl+N')
    app.openNewStatusDialogAction.triggered.connect(openNewStatusDialog)
    app.addAccountAction = QAction("Add Account", app)
    app.addAccountAction.triggered.connect(addNewAccountWithDialog)
    app.addTabAction = QAction("New Tab", app)
    app.addTabAction.setShortcut('Ctrl+T')
    app.addTabAction.triggered.connect(app.addNewTabWithDialog)
    app.searchAction = QAction("Search", app)
    app.searchAction.triggered.connect(app.openSearchDialog)
    app.settingsAction = QAction("Settings", app)
    app.settingsAction.triggered.connect(app.openGlobalSettingsDialog)
    app.firehoseAction = QAction("Firehose", app)
    app.firehoseAction.setCheckable(True)
    app.firehoseAction.triggered.connect(app.firehoseActionChanged)
    app.syncDBAction = QAction("Sync Local Database", app)
    app.syncDBAction.triggered.connect(fp_sqlite.syncDirtyObjects)
    app.saveTabsAction = QAction("Save Persistent Tabs", app)
    app.saveTabsAction.triggered.connect(app.savePersistentTabs)
    app.marryAmericanWomanAction = QAction("Marry an American Woman...", app)
    app.marryAmericanWomanAction.triggered.connect(app.marryAmericanWoman)